## rpiboot 0~20220315%2Bgit6fa2ec0%2Bnowin

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/pkg-info.mk

%:
	dh $@

# Makefile does not follow any conventions
override_dh_auto_install:
	true

override_dh_fixperms:
	dh_fixperms
	chmod -x $$(find debian/rpiboot -name "*.bin" -o -name "*.elf")

override_dh_dwz:
	dh_dwz -Xstart.elf -Xstart4.elf

override_dh_strip:
	dh_strip -Xstart.elf -Xstart4.elf

get-orig-source:
	DEB_SOURCE="$(DEB_SOURCE)" DEB_VERSION_UPSTREAM="$(DEB_VERSION_UPSTREAM)" \
		   debian/get-orig-source

## rpiboot 0~20220315+git6fa2ec0+nowin

=== Makefile ===
PKG_VER=$(shell grep rpiboot debian/changelog | head -n1 | sed 's/.*(\(.*\)).*/\1/g')
GIT_VER=$(shell git rev-parse HEAD 2>/dev/null | cut -c1-8 || echo "")
rpiboot: main.c msd/bootcode.h msd/start.h msd/bootcode4.h msd/start4.h
	$(CC) -Wall -Wextra -g -o $@ $< `pkg-config --cflags --libs libusb-1.0` -DGIT_VER="\"$(GIT_VER)\"" -DPKG_VER="\"$(PKG_VER)\""

%.h: %.bin ./bin2c
	./bin2c $< $@

%.h: %.elf ./bin2c
	./bin2c $< $@

bin2c: bin2c.c
	$(CC) -Wall -Wextra -g -o $@ $<

install: rpiboot
	install -m 755 rpiboot /usr/bin/
	install -d /usr/share/rpiboot
	install -m 644 msd/bootcode.bin  /usr/share/rpiboot/
	install -m 644 msd/bootcode4.bin /usr/share/rpiboot/
	install -m 644 msd/start.elf  /usr/share/rpiboot/
	install -m 644 msd/start4.elf /usr/share/rpiboot/

uninstall:
	rm -f /usr/bin/rpiboot
	rm -f /usr/share/rpiboot/bootcode.bin
	rm -f /usr/share/rpiboot/bootcode4.bin
	rm -f /usr/share/rpiboot/start.elf
	rm -f /usr/share/rpiboot/start4.elf
	rmdir --ignore-fail-on-non-empty /usr/share/rpiboot/

clean:
	rm -f rpiboot msd/*.h bin2c

.PHONY: uninstall clean

=== debian/changelog ===
rpiboot (0~20220315+git6fa2ec0+nowin-0ubuntu1) jammy; urgency=medium

  * Initial import into Ubuntu. (LP: #1959592)

 -- Dave Jones <dave.jones@canonical.com>  Mon, 31 Jan 2022 15:23:38 +0000

=== debian/control ===
Source: rpiboot
Section: utils
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Serge Schneider <serge@raspberrypi.com>
Build-Depends:
 debhelper-compat (= 13),
 libusb-1.0-0-dev,
 pkg-config
Standards-Version: 4.5.1
Homepage: https://github.com/raspberrypi/usbboot

Package: rpiboot
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, python3
Description: Raspberry Pi USB booting code
 USB MSD boot code which should work on the Raspberry Pi model A, Compute
 Module, Compute Module 3, Compute Module 4, Zero, Zero W, and Zero 2.
 .
 Also includes utilities for working with secure boot on the Raspberry Pi 4
 series (including Compute Module 4 and certain board revisions of the 4B and
 400).

## rpiboot 0~20240926~102326%2Bgit82d8755%2Bnowin

=== Makefile ===
PKG_VER=$(shell grep rpiboot debian/changelog | head -n1 | sed 's/.*(\(.*\)).*/\1/g')
GIT_VER=$(shell git rev-parse HEAD 2>/dev/null | cut -c1-8 || echo "")
INSTALL_PREFIX?=/usr

rpiboot: main.c bootfiles.c decode_duid.c msd/bootcode.h msd/start.h msd/bootcode4.h msd/start4.h
	$(CC) -Wall -Wextra -g -o $@ main.c bootfiles.c decode_duid.c `pkg-config --cflags --libs libusb-1.0` -DGIT_VER="\"$(GIT_VER)\"" -DPKG_VER="\"$(PKG_VER)\"" -DINSTALL_PREFIX=\"$(INSTALL_PREFIX)\"

%.h: %.bin ./bin2c
	./bin2c $< $@

%.h: %.elf ./bin2c
	./bin2c $< $@

bin2c: bin2c.c
	$(CC) -Wall -Wextra -g -o $@ $<

install: rpiboot
	install -m 755 rpiboot $(INSTALL_PREFIX)/bin/
	install -d $(INSTALL_PREFIX)/share/rpiboot
	install -d $(INSTALL_PREFIX)/share/rpiboot/msd
	install -d $(INSTALL_PREFIX)/share/rpiboot/mass-storage-gadget64
	install -m 644 msd/bootcode.bin  $(INSTALL_PREFIX)/share/rpiboot/msd
	install -m 644 msd/bootcode4.bin $(INSTALL_PREFIX)/share/rpiboot/msd
	install -m 644 msd/start.elf  $(INSTALL_PREFIX)/share/rpiboot/msd
	install -m 644 msd/start4.elf $(INSTALL_PREFIX)/share/rpiboot/msd
	install -m 644 mass-storage-gadget64/boot.img $(INSTALL_PREFIX)/share/rpiboot/mass-storage-gadget64
	install -m 644 mass-storage-gadget64/config.txt $(INSTALL_PREFIX)/share/rpiboot/mass-storage-gadget64
	install -m 644 mass-storage-gadget64/bootfiles.bin $(INSTALL_PREFIX)/share/rpiboot/mass-storage-gadget64

uninstall:
	rm -f $(INSTALL_PREFIX)/bin/rpiboot
	rm -rf $(INSTALL_PREFIX)/share/rpiboot

clean:
	rm -f rpiboot msd/*.h bin2c

.PHONY: uninstall clean

## rpiboot 0~20240926~102326+git82d8755+nowin

=== debian/changelog ===
rpiboot (0~20240926~102326+git82d8755+nowin-0ubuntu1) plucky; urgency=medium

  * New upstream release, 20240926~102326 (LP: #2032178)
  * d/control: bump standards version

 -- Dave Jones <dave.jones@canonical.com>  Wed, 30 Oct 2024 10:30:02 +0100

rpiboot (20240926~102326) bookworm; urgency=medium

  [ Tim Gover ]
  * Delete state pieeprom.bin files for recovery / recovery5
  * docs: Update Pi5 secure-boot docs
  * secure-boot: 2712: Update to docs to indicate BETA status
  * docs: Remove BETA tag from secure-boot on Pi5
  * recovery: Remove the stale pieeprom.sig and pieeprom.bin files
  * firmware: 2712: Update to the 2024-09-10 default release
  * mass-storage-gadget: Deprecate this in favour of the 64-bit image
  * secure-boot-recovery: Disable write-protect in the reference config.txt file
  * secure-boot-recovery: Include the recovery_metadata documentation
  * sign.sh: Add a log message to indicate that boot.img is being signed
  * firmware: 2712: Update to the 2024-09-23 default release

 -- Serge Schneider <serge@raspberrypi.com>  Thu, 26 Sep 2024 13:46:50 +0100

rpiboot (20240820~105714) bookworm; urgency=medium

  [ Tim Gover ]
  * rpiboot: Increase ep_read control transfer timeout

 -- Serge Schneider <serge@raspberrypi.com>  Tue, 20 Aug 2024 12:02:35 +0100

rpiboot (20240816~170020) bookworm; urgency=medium

  [ Tom Dewey ]
  * secure-boot-recovery5: Fixup wording around recovery.bin

  [ Giampiero Baggiani ]
  * recovery5 README minor fix

  [ Tim Gover ]
  * firmware: 2711: Update to latest Pi4 firmware pieeprom-2024-05-17.bin
  * mass-storage-gadget64-cm3: Create a 64-bit mass-storage gadget for CM3
  * recovery: Add config.txt with example options
  * firmware: Update to the latest 2712 firmware - 2024-06-05
  * firmware: 2711: Move to the 2024-07-30 release
  * mass-storage-gadget64: boot.img: Add USB serial gadget
  * firmware: bootfiles: Update for preliminary CM5 Lite support
  * docs: Guide users towards Raspberry Pi secure-boot provisioner
  * firmware: Update 2711/2712 firmware for OTP metadata and use latest 2712
    bootloader
  * recovery: recovery5: Fixup meta-data comments in config.txt
  * debian: Pull the firmware files from installed rpi-eeprom package
  * debian: Require rpi-eeprom version >= 24

  [ martamomotko ]
  * rpiboot: Update to check if directory exists
  * rpiboot: Add metadata output option
  * Fix parsing of the DUID metadata string

  [ Chris Burton ]
  * Add missing newline.

  [ Serge Schneider ]
  * Lintian fixes

 -- Serge Schneider <serge@raspberrypi.com>  Mon, 19 Aug 2024 23:21:53 +0100

rpiboot (20240422~085300) bookworm; urgency=medium

  [ Tim Gover ]
  * bootloader: Update to 2023-01-11 release
  * secure-boot-recovery: boot.conf - Update BOOT_ORDER to include NVMe
  * Update secure-boot docs - add chain of trust diagram
  * Update EEPROM image to pieeprom-2023-05-11
  * bootfiles: Load EEPROM DDR FW from bootfiles.bin
  * recovery5: Preliminary support for EEPROM updates on Pi5
  * mass-storage-gadget64: Add 64-bit mass-storage-gadget for BCM2711 BCM2712
  * rpiboot: Update top level docs for Raspberry Pi 5
  * windows: Add windows support for Raspberry Pi 5
  * gitignore: Ignore Vi .swp files
  * rpiboot: Read firmware from a package (.tar) file
  * rpiboot: Add support for 2712 USB descriptors
  * bootfiles: Move to firmware sub-directory
  * documentation: Fixup .org URLs
  * Update 2712 firmware to pieeprom-2024-02-16 release
  * mass-storage-gadget64: Update for preliminary BCM2712D0 and CM5 support
  * docs: Note that CM4S is compatible with CM4S RPIBOOT software
  * mass-storage-gadget64: Reduce image size, fix DHCP and autologin to consoles
  * rpi-eeprom: debian: Import rpi-eeprom tools as a submodule
  * Readme.md: Fix some markdown issues
  * bootloader: Use rpi-eeprom submodule for bootloader binaries
  * update-pieeprom: Use system versions of rpi-eeprom tools in APT installs
  * Update debian package following submodule reorg
  * Makefile: Update install to use same msd path as APT
  * Makefile: Add support for INSTALL_PREFIX
  * 2712: Default to mass-storage-gadget64 if no direcoty is specified
  * win32: Update for submodules and drop recovery
  * readme: Specify the python3-cryptodome library instead of pip install
  * recovery5: pieeprom.original.bin should be a symlink
  * firmware: Update the 2711 bootloader to pieeprom-2024-04-15
  * firmware: Update 2711 firmware in bootfiles.bin with secure-boot support
  * bootfiles: Use the bootfiles loader for mass-storage gadget images
  * secure-boot-recovery: Document the reboot flag
  * mass-storage-gadget64: Update for CM5
  * BCM2712: Preliminary tool support for secure-boot
  * firmware: Update 2712 to 2024-04-20 release

  [ Torben Woltjen ]
  * Fix typo that resulted in opposite meaning (does -> doesn't)

  [ Phil Elwell ]
  * README: Include build-essential as a pre-requisite

  [ TM ]
  * Fix typo

  [ mennovf ]
  * Update install_script.nsi

  [ Peter Harper ]
  * Increase timeout for libusb_control_transfer
  * Add options to set the key offset and length

  [ axel simon ]
  * fix link to ./tools/rpi-otp-private-key

  [ Rory B ]
  * fix typo

  [ Tom Dewey ]
  * rpiboot: Allow selecting by serial number
  * rpiboot: review feedback
  * rpiboot: review second round
  * rpiboot: Close libusb handles during search
  * rpiboot: Use libusb without prefix
  * rpiboot: Fixup USB VID typo
  * rpiboot: Update 05ac log message

 -- Tim Gover <tim.gover@raspberrypi.com>  Mon, 22 Apr 2024 08:53:16 +0100

rpiboot (20221215~105525) bullseye; urgency=medium

  [ Tim Gover ]
  * rpi-eeprom-digest: Only require openssl + xxd for RSA operations
  * verifySig tidyup
  * docs: Update mass-storage gadget + secure-boot
  * secure-boot-example: Update boot.img and docs for cryptsetup example
  * Update issue templates
  * git: Create tags that match the APT releases
  * bin2c: Add cast to silence isalnum warning
  * usbboot: Indicate when a file is missing / empty.


=== debian/control ===
Source: rpiboot
Section: utils
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Serge Schneider <serge@raspberrypi.com>
Build-Depends:
 debhelper-compat (= 13),
 libusb-1.0-0-dev,
 pkgconf,
 rpi-eeprom-firmware (>= 26),
Standards-Version: 4.6.2
Homepage: https://github.com/raspberrypi/usbboot
Rules-Requires-Root: no

Package: rpiboot
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
 python3,
 rpi-eeprom-firmware (>= 26),
Description: Raspberry Pi USB booting code
 USB MSD boot code which should work on the Raspberry Pi model A,
 Compute Module, Compute Module 3, Compute Module 4, Compute Module 5,
 Raspberry Pi 5 and Raspberry Pi Zero.
 .
 Also includes utilities for working with secure boot on the Raspberry Pi 4
 series (including Compute Module 4 and certain board revisions of the 4B and
 400).

=== debian/rules ===
--- 
+++ 
@@ -19,6 +19,20 @@
 override_dh_strip:
 	dh_strip -Xstart.elf -Xstart4.elf
 
+override_dh_install:
+	# Copy the pinned firmware version
+	rm -rf temp
+	mkdir -p temp/firmware/2711
+	mkdir -p temp/firmware/2712
+
+	cp /lib/firmware/raspberrypi/bootloader-2711/latest/pieeprom-2024-07-30.bin temp/firmware/2711/pieeprom.bin
+	cp /lib/firmware/raspberrypi/bootloader-2711/latest/recovery.bin temp/firmware/2711/recovery.bin
+	cp /lib/firmware/raspberrypi/bootloader-2712/latest/pieeprom-2024-09-23.bin temp/firmware/2712/pieeprom.bin
+	cp /lib/firmware/raspberrypi/bootloader-2712/latest/recovery.bin temp/firmware/2712/recovery.bin
+	dh_install
+	find $(CURDIR)/debian -name .gitignore -delete
+	rm -rf temp
+
 get-orig-source:
 	DEB_SOURCE="$(DEB_SOURCE)" DEB_VERSION_UPSTREAM="$(DEB_VERSION_UPSTREAM)" \
 		   debian/get-orig-source

=== debian/watch ===
version=4

opts=\
  repacksuffix=+nowin,\
  dversionmangle=s/\+nowin$//,\
  filenamemangle=s/.*\/@ANY_VERSION@\.tar\.gz/@PACKAGE@_$1\.orig\.tar\.gz/ \
  https://github.com/raspberrypi/usbboot/tags .*/@ANY_VERSION@\.tar\.gz

## rpiboot 20221215~105526~buster

=== debian/changelog ===
rpiboot (20221215~105526~buster) buster; urgency=medium

  * Release for buster

 -- Serge Schneider <serge@raspberrypi.com>  Tue, 17 Jan 2023 15:37:06 +0000

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@

# Makefile does not follow any conventions
override_dh_auto_install:
	true

override_dh_strip:
	dh_strip -Xstart.elf -Xstart4.elf

override_dh_install:
	dh_install
	find $(CURDIR)/debian -name .gitignore -delete

## rpiboot 20250908~162618~bookworm

=== debian/changelog ===
rpiboot (20250908~162618~bookworm) bookworm; urgency=medium

  * debian: Update rpi-eeprom dependency versions

 -- Tim Gover <tim.gover@raspberrypi.com>  Mon, 08 Sep 2025 16:55:01 +0100

rpiboot (20250519~100421) bookworm; urgency=medium

  * secure-boot-recovery: program_pubkey now automatically sets
    revoke_devkey
  * windows: Update for BCM2711/BCM2712 2025-05-08 firmware + generic
    BCM2710 and older msd.elf
  * debian: Update rpi-eeprom dependencies for recovery.bin
    (revoke_devkey)

 -- Tim Gover <tim.gover@raspberrypi.com>  Mon, 19 May 2025 11:50:02 +0100

rpiboot (20250516~140109) bookworm; urgency=medium

  * rules: Update the 2711/2712 bootloaders to 2025-05-08

 -- Tim Gover <tim.gover@raspberrypi.com>  Fri, 16 May 2025 14:01:09 +0100

rpiboot (20250514~214724) bookworm; urgency=medium

  [ Tim Gover ]
  * mass-storage-gadget: Update to rpi-6.12.y kernel
  * mass-storage-gadget64-cm4: Update to rpi-6.12 kernel
  * Add a Hardware Security Module wrapper script interface
  * WIP: Add Github CI workflow tests
  * test: Add a README.md and test CI
  * firmware: 2712: 2711: Move to the 2025-05-08 release

  [ Gaël PORTAY ]
  * secure-boot-recovery: Fix typo

 -- Tim Gover <tim.gover@raspberrypi.com>  Thu, 15 May 2025 17:24:23 +0100

rpiboot (20250401~081331) bookworm; urgency=medium

  [ Tim Gover ]
  * Add support for overriding files in bootfiles.bin
  * mass-storage-gadget64-cm3: Update GPU firmware for 2710 and older
    devices
  * msd: Remove legacy msd/start4.elf and use a common legacy msd .elf
    file
  * rpi-make-boot-image: Drop start4x on 2711
  * rpi-make-boot-image: Don't include Pi5 specific kernel + initramfs in
    pi4 mode
  * mass-storage-gadget64: Update boot.img for util-linux blkid tools
  * firmware: 2712: Update to pieeprom-2025-03-10
  * update-pieeprom: Fix handling for SRC_IMAGE in code-signing mode
  * update-pieeprom.sh: Remove redundant SIGNED_BOOT=1 flag
  * make: Remove BUILD_TIMESTAMP
  * update-pieeprom.sh: Initialise SIGN_FIRMWARE variable
  * firmware: Update rpi-eeprom submodule

  [ Richard Oliver ]
  * rpi-make-boot-image: Prefer 512-byte clusters
  * rpi-make-boot-image: Set disk geometry
  * rpi-make-boot-image: Use KiB for sizes internally
  * rpi-make-boot-image: Estimate size with clusters
  * udev: Deauthorise boot rom usb-storage
  * pkg: Include mass-storage-gadget64-cm3

  [ Leon Anavi ]
  * secure-boot-example/README.md: Fix typo

  [ Matt Wildoer ]
  * Update Makefile to handle date formatting for macOS compatibility

 -- Tim Gover <tim.gover@raspberrypi.com>  Tue, 01 Apr 2025 08:14:36 +0100

rpiboot (20250227~132106) bookworm; urgency=medium

  * version: Drop git-version prefix

 -- Tim Gover <tim.gover@raspberrypi.com>  Thu, 27 Feb 2025 13:22:44 +0000

rpiboot (20250227~123606) bookworm; urgency=medium

  * makefile: Fix check for debian/changelog in PKG_VER
  * makefile: Pass build-date as a make flag for reproducible builds
  * main: Tidyup error handling in second stage setup

 -- Tim Gover <tim.gover@raspberrypi.com>  Thu, 27 Feb 2025 13:06:00 +0000

rpiboot (20250226~171348) bookworm; urgency=medium

  * makefile: Only set the PKG_VERSION in APT builds
  * debian: Remove debian build scripts from master

 -- Tim Gover <tim.gover@raspberrypi.com>  Thu, 27 Feb 2025 12:16:06 +0000

rpiboot (20250226~163138) bookworm; urgency=medium

  * readme: Expand build instructions to mention 'make install' and
    INSTALL_PREFIX
  * salsa-ci: Add the extract source section as with rpi-eeprom
  * debian: rpi-make-boot-image: Drop direct dependency on coreutils and
    tar
  * makefile: Pass CPPFLAGS - required for APT (debian/hardening)

 -- Tim Gover <tim.gover@raspberrypi.com>  Wed, 26 Feb 2025 16:33:08 +0000

rpiboot (20250221~161557) bookworm; urgency=medium

  * win32: Update windows installer for latest bootfiles.bin firmware
  * firmware: 2712: Update to the 2025-02-12 release
  * 2712: Fix incorrect filename for pieeprom.bin
  * firmware: 2711: Update to the 2025-02-11 release
  * rpiboot: Use mass-storage-gadget-64 by default on BCM2711
  * debian: Add a build time dependency on xxd
  * Add gbp.conf
  * debian: Require rpi-eeprom >= 27.4
  * debian: Select pieeprom-2025-02-12-2712 and pieeprom-2025-02-11-2711

 -- Tim Gover <tim.gover@raspberrypi.com>  Fri, 21 Feb 2025 16:45:08 +0000

rpiboot (20250129~123632) bookworm; urgency=medium

  [ Tim Gover ]
  * recovery5: Remove redundant recovery.bin file
  * secure-boot-recovery5: Fixup recovery.bin link
  * win32: Remove the redundant .bat file for 32-bit mass-storage gadget
  * win32: Include product names in rpiboot shortcut links
  * win32: Add a help message to the mass-storage-gadget batch file
  * win32: Update the installer executable
  * mass-storage-gadget64: Add mmc-utils and other useful commands
  * 2712: Update recommended boot.conf for default provisioning setup
  * Remvove the 32-bit mass-storage-gadget
  * Make mass-storage-gadget a symlink to mass-storage-gadget64
  * rpi-imager-embedded: Remove the old version of the imager boot.img
  * readme: Assorted update for Compute Module 5
  * mass-storage-gadget64: docs - Fix comments in config.txt
  * secure-boot-recovery: Update README for Pi4 instructions
  * firmware: 2712: Move to the 2024-11-27 release
  * rpiboot: Provide a short link to the troubleshooting guide on startup
  * secure-boot-example: Update to work on both Compute Module 4 and
    Compute Module 5
  * pi5: Improve path handling if bootfiles.bin is not found
  * firmware: 2712: Update to pieeprom-2025-01-22
  * mass-storage-64: Restore symlink to bootfiles.bin
  * README: mass-storage-gadget -> mass-storage-gadget64
  * rpiboot: Add note about rpiboot jumper to the startup guidance

  [ tinyboxvk ]
  * Update Readme.md
  * Update Readme.md
  * Update README.md
  * Update config.txt
  * Update config.txt
  * Update Readme.md
  * Fix typos

  [ Stanislav Kusovskyi ]
  * mass-storage-gadget64: fix invokes of extra tools in sign.sh



## rpiboot 20250908~162618

=== Makefile ===
BUILD_DATE ?= $(shell date "+%Y/%m/%d")
PKG_VER=$(shell if [ -f debian/changelog ]; then grep rpiboot debian/changelog | head -n1 | sed 's/.*(\(.*\)).*/\1/g'; else echo local; fi)
GIT_VER=$(shell git rev-parse HEAD 2>/dev/null | cut -c1-8 || echo "")
HAVE_XXD=$(shell xxd -v >/dev/null 2>/dev/null && echo y)
INSTALL_PREFIX?=/usr

rpiboot: main.c bootfiles.c decode_duid.c msd/bootcode.h msd/start.h msd/bootcode4.h
	$(CC) -Wall -Wextra -g $(CPPFLAGS) $(CFLAGS) -o $@ main.c bootfiles.c decode_duid.c `pkg-config --cflags --libs libusb-1.0` -DGIT_VER="\"$(GIT_VER)\"" -DPKG_VER="\"$(PKG_VER)\"" -DBUILD_DATE="\"$(BUILD_DATE)\"" -DINSTALL_PREFIX=\"$(INSTALL_PREFIX)\" $(LDFLAGS)

ifeq ($(HAVE_XXD),y)
%.h: %.bin
	xxd -i $< > $@

%.h: %.elf
	xxd -i $< > $@
else
CC_FOR_BUILD ?= $(CC)

%.h: %.bin ./bin2c
	./bin2c $< $@

%.h: %.elf ./bin2c
	./bin2c $< $@

bin2c: bin2c.c
	$(CC_FOR_BUILD) -Wall -Wextra -g -o $@ $<

endif

install: rpiboot
	install -m 755 rpiboot $(INSTALL_PREFIX)/bin/
	install -d $(INSTALL_PREFIX)/share/rpiboot
	install -d $(INSTALL_PREFIX)/share/rpiboot/msd
	install -d $(INSTALL_PREFIX)/share/rpiboot/mass-storage-gadget64
	install -m 644 msd/bootcode.bin  $(INSTALL_PREFIX)/share/rpiboot/msd
	install -m 644 msd/bootcode4.bin $(INSTALL_PREFIX)/share/rpiboot/msd
	install -m 644 msd/start.elf  $(INSTALL_PREFIX)/share/rpiboot/msd
	install -m 644 mass-storage-gadget64/boot.img $(INSTALL_PREFIX)/share/rpiboot/mass-storage-gadget64
	install -m 644 mass-storage-gadget64/config.txt $(INSTALL_PREFIX)/share/rpiboot/mass-storage-gadget64
	install -m 644 mass-storage-gadget64/bootfiles.bin $(INSTALL_PREFIX)/share/rpiboot/mass-storage-gadget64

uninstall:
	rm -f $(INSTALL_PREFIX)/bin/rpiboot
	rm -rf $(INSTALL_PREFIX)/share/rpiboot

clean:
	rm -f rpiboot msd/*.h bin2c

.PHONY: uninstall clean

=== debian/changelog ===
rpiboot (20250908~162618) trixie; urgency=medium

  * debian: firmware: Update to 2025-08-27

 -- Tim Gover <tim.gover@raspberrypi.com>  Mon, 08 Sep 2025 16:48:25 +0100

rpiboot (20250519~100421+trixie) trixie; urgency=medium

  * Switch gbp.conf debian branch to pios/trixie

 -- Serge Schneider <serge@raspberrypi.com>  Tue, 29 Jul 2025 13:21:23 +0100

=== debian/control ===
Source: rpiboot
Section: utils
Priority: optional
Maintainer: Serge Schneider <serge@raspberrypi.com>
Build-Depends: debhelper-compat (= 13), libusb-1.0-0-dev, pkg-config, rpi-eeprom (>= 28.5), xxd
Standards-Version: 4.5.1
Homepage: https://github.com/raspberrypi/usbboot

Package: rpiboot
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, python3, rpi-eeprom (>= 28.5)
Description: Raspberry Pi USB booting code
 USB MSD boot code which should work on the Raspberry Pi model A,
 Compute Module, Compute Module 3, Compute Module 4, Compute Module 5,
 Raspberry Pi 5 and Raspberry Pi Zero.

Package: rpi-make-boot-image
Architecture: any
Depends: dosfstools, file, mount
Recommends: mtools
Description: Utility to create Raspberry Pi minimal boot ramdisk files.
  Utility for building Raspberry Pi bootloader ramdisk (boot.img) files.
  These images are raw FAT images and the tool attempts to make this as small as possible to reduce load time.

=== debian/rules ===
--- 
+++ 
@@ -11,5 +11,15 @@
 	dh_strip -Xstart.elf -Xstart4.elf
 
 override_dh_install:
+	# Copy the pinned firmware version
+	rm -rf temp
+	mkdir -p temp/firmware/2711
+	mkdir -p temp/firmware/2712
+
+	cp /lib/firmware/raspberrypi/bootloader-2711/latest/pieeprom-2025-08-27.bin temp/firmware/2711/pieeprom.bin
+	cp /lib/firmware/raspberrypi/bootloader-2711/latest/recovery.bin temp/firmware/2711/recovery.bin
+	cp /lib/firmware/raspberrypi/bootloader-2712/latest/pieeprom-2025-08-27.bin temp/firmware/2712/pieeprom.bin
+	cp /lib/firmware/raspberrypi/bootloader-2712/latest/recovery.bin temp/firmware/2712/recovery.bin
 	dh_install
 	find $(CURDIR)/debian -name .gitignore -delete
+	rm -rf temp

## rpiboot 20251002~150524~bookworm

=== debian/changelog ===
rpiboot (20251002~150524~bookworm) bookworm; urgency=medium

  [ Jack O'Brien ]
  * secure-boot-recovery5: Added verbose docs about debug serial ports.
  * secure-boot-recovery5: BCM2712 needs burnt OTP for signed pieeprom
  * secure-boot-recovery5: Clarify docs about config.txt

  [ Tim Gover ]
  * firmware: 2711: Fixup link to 2711 instead of 2712 firmware
  * mass-storage-gadget: Remove mass-storage-gadget64-cm3
  * mass-storage-gadget: Update boot.img to use MAC address for DHCP
    identifier
  * readme: Document APT install location for rpiboot utilities

 -- Tim Gover <tim.gover@raspberrypi.com>  Thu, 02 Oct 2025 16:08:21 +0100

## rpiboot 20251002~150524

=== debian/changelog ===
rpiboot (20251002~150524) trixie; urgency=medium

  [ Jack O'Brien ]
  * secure-boot-recovery5: Added verbose docs about debug serial ports.
  * secure-boot-recovery5: BCM2712 needs burnt OTP for signed pieeprom
  * secure-boot-recovery5: Clarify docs about config.txt

  [ Tim Gover ]
  * firmware: 2711: Fixup link to 2711 instead of 2712 firmware
  * mass-storage-gadget: Remove mass-storage-gadget64-cm3
  * mass-storage-gadget: Update boot.img to use MAC address for DHCP
    identifier
  * readme: Document APT install location for rpiboot utilities

 -- Tim Gover <tim.gover@raspberrypi.com>  Thu, 02 Oct 2025 15:10:58 +0100

## rpiboot 20251107~092017~bookworm

=== debian/changelog ===
rpiboot (20251107~092017~bookworm) bookworm; urgency=medium

  [ Andrew Scheller ]
  * Fix help-text formatting for rpi-make-boot-image
  * Remove inconsistent full stops

  [ Tim Gover ]
  * tools: rpi-get-latest-fw: Updates the Pi4 / Pi5 firmware release
  * firmware: 2711: 2712: Update to 2025-11-05
  * firmware: Update to 2025-11-07 - rpi-eeprom 28.7

 -- Tim Gover <tim.gover@raspberrypi.com>  Tue, 11 Nov 2025 14:50:25 +0000

=== debian/control ===
--- 
+++ 
@@ -2,13 +2,13 @@
 Section: utils
 Priority: optional
 Maintainer: Serge Schneider <serge@raspberrypi.com>
-Build-Depends: debhelper-compat (= 13), libusb-1.0-0-dev, pkg-config, rpi-eeprom (>= 28.5), xxd
+Build-Depends: debhelper-compat (= 13), libusb-1.0-0-dev, pkg-config, rpi-eeprom (>= 28.7), xxd
 Standards-Version: 4.5.1
 Homepage: https://github.com/raspberrypi/usbboot
 
 Package: rpiboot
 Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}, python3, rpi-eeprom (>= 28.5)
+Depends: ${shlibs:Depends}, ${misc:Depends}, python3, rpi-eeprom (>= 28.7)
 Description: Raspberry Pi USB booting code
  USB MSD boot code which should work on the Raspberry Pi model A,
  Compute Module, Compute Module 3, Compute Module 4, Compute Module 5,

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@

# Makefile does not follow any conventions
override_dh_auto_install:
	true

override_dh_strip:
	dh_strip -Xstart.elf -Xstart4.elf

override_dh_install:
	# Copy the pinned firmware version
	rm -rf temp
	mkdir -p temp/firmware/2711
	mkdir -p temp/firmware/2712

	cp /lib/firmware/raspberrypi/bootloader-2711/latest/pieeprom-2025-11-05.bin temp/firmware/2711/pieeprom.bin
	cp /lib/firmware/raspberrypi/bootloader-2711/latest/recovery.bin temp/firmware/2711/recovery.bin
	cp /lib/firmware/raspberrypi/bootloader-2712/latest/pieeprom-2025-11-05.bin temp/firmware/2712/pieeprom.bin
	cp /lib/firmware/raspberrypi/bootloader-2712/latest/recovery.bin temp/firmware/2712/recovery.bin
	dh_install
	find $(CURDIR)/debian -name .gitignore -delete
	rm -rf temp

## rpiboot 20251107~092017

=== debian/changelog ===
rpiboot (20251107~092017) trixie; urgency=medium

  [ Andrew Scheller ]
  * Fix help-text formatting for rpi-make-boot-image
  * Remove inconsistent full stops

  [ Tim Gover ]
  * tools: rpi-get-latest-fw: Updates the Pi4 / Pi5 firmware release
  * firmware: 2711: 2712: Update to 2025-11-05
  * firmware: Update to 2025-11-05 with rpi-eeprom >= 28.8

 -- Tim Gover <tim.gover@raspberrypi.com>  Tue, 11 Nov 2025 12:14:28 +0000

=== debian/control ===
--- 
+++ 
@@ -2,13 +2,13 @@
 Section: utils
 Priority: optional
 Maintainer: Serge Schneider <serge@raspberrypi.com>
-Build-Depends: debhelper-compat (= 13), libusb-1.0-0-dev, pkg-config, rpi-eeprom (>= 28.7), xxd
+Build-Depends: debhelper-compat (= 13), libusb-1.0-0-dev, pkg-config, rpi-eeprom (>= 28.8), xxd
 Standards-Version: 4.5.1
 Homepage: https://github.com/raspberrypi/usbboot
 
 Package: rpiboot
 Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}, python3, rpi-eeprom (>= 28.7)
+Depends: ${shlibs:Depends}, ${misc:Depends}, python3, rpi-eeprom (>= 28.8)
 Description: Raspberry Pi USB booting code
  USB MSD boot code which should work on the Raspberry Pi model A,
  Compute Module, Compute Module 3, Compute Module 4, Compute Module 5,

## rpiboot 20251202~164822

=== debian/changelog ===
rpiboot (20251202~164822) trixie; urgency=medium

  [ Tim Gover ]
  * mass-storage-gadget: Fix EMMC access on CM3+ and CM3E
  * Move trouble-shooting to a separate page
  * docs: secure-boot pi4 tidyup
  * docs: Move diagnostics to the troubleshooting page
  * docs: Move secure-boot reference to a sub-page
  * docs: readme: Minor tidyups and fix links
  * docs: Readme: Highlight mass-storage-gadget and device compatibility
  * docs: secure-boot: Add note about counter-signing.
  * rpi-eeprom: Update for make-pi4-rpiboot-gpio-sd utility
  * readme: Update product names
  * docs: Describe how to enable rpiboot on Pi 4B and Pi 400
  * docs: readme: make-pi4-rpiboot-gpio dependencies
  * docs: secure-boot: Describe the HSM wrapper API
  * firmware: 2712: 2711 bootfiles.bin: Update to 2025-11-27 firmware
  * firmware: 2712: 2711: Update to 2025-11-27
  * tools: Move APT release scripts into a sub-directory
  * apt: update rpi-eeprom dependency

  [ martamomotko ]
  * rpiboot: Output metadata to stdout when path not provided or invalid
  * rpiboot: Enable metadata output by default when metadata is received
    Metadata information is now written to stdout by default when received
    from BCM2712/2711 devices. The -j flag can be used to specify a
    directory for a JSON file output instead. To instruct recovery.bin to
    stop sending metadata, explicitly set recovery_metadata=0 in
    config.txt.

 -- Tim Gover <tim.gover@raspberrypi.com>  Tue, 02 Dec 2025 19:44:24 +0000

=== debian/control ===
--- 
+++ 
@@ -2,13 +2,13 @@
 Section: utils
 Priority: optional
 Maintainer: Serge Schneider <serge@raspberrypi.com>
-Build-Depends: debhelper-compat (= 13), libusb-1.0-0-dev, pkg-config, rpi-eeprom (>= 28.8), xxd
+Build-Depends: debhelper-compat (= 13), libusb-1.0-0-dev, pkg-config, rpi-eeprom (>= 28.9), xxd
 Standards-Version: 4.5.1
 Homepage: https://github.com/raspberrypi/usbboot
 
 Package: rpiboot
 Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}, python3, rpi-eeprom (>= 28.8)
+Depends: ${shlibs:Depends}, ${misc:Depends}, python3, rpi-eeprom (>= 28.9)
 Description: Raspberry Pi USB booting code
  USB MSD boot code which should work on the Raspberry Pi model A,
  Compute Module, Compute Module 3, Compute Module 4, Compute Module 5,

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@

# Makefile does not follow any conventions
override_dh_auto_install:
	true

override_dh_strip:
	dh_strip -Xstart.elf -Xstart4.elf

override_dh_install:
	# Copy the pinned firmware version
	rm -rf temp
	mkdir -p temp/firmware/2711
	mkdir -p temp/firmware/2712

	cp /lib/firmware/raspberrypi/bootloader-2711/latest/pieeprom-2025-11-27.bin temp/firmware/2711/pieeprom.bin
	cp /lib/firmware/raspberrypi/bootloader-2711/latest/recovery.bin temp/firmware/2711/recovery.bin
	cp /lib/firmware/raspberrypi/bootloader-2712/latest/pieeprom-2025-11-27.bin temp/firmware/2712/pieeprom.bin
	cp /lib/firmware/raspberrypi/bootloader-2712/latest/recovery.bin temp/firmware/2712/recovery.bin
	dh_install
	find $(CURDIR)/debian -name .gitignore -delete
	rm -rf temp

## rpiboot 20251209~095558~bookworm

=== debian/changelog ===
rpiboot (20251209~095558~bookworm) bookworm; urgency=medium

  [ Tim Gover ]
  * mass-storage-gadget: Fix EMMC access on CM3+ and CM3E
  * Move trouble-shooting to a separate page
  * docs: secure-boot pi4 tidyup
  * docs: Move diagnostics to the troubleshooting page
  * docs: Move secure-boot reference to a sub-page
  * docs: readme: Minor tidyups and fix links
  * docs: Readme: Highlight mass-storage-gadget and device compatibility
  * docs: secure-boot: Add note about counter-signing.
  * rpi-eeprom: Update for make-pi4-rpiboot-gpio-sd utility
  * readme: Update product names
  * docs: Describe how to enable rpiboot on Pi 4B and Pi 400
  * docs: readme: make-pi4-rpiboot-gpio dependencies
  * docs: secure-boot: Describe the HSM wrapper API
  * firmware: 2712: 2711 bootfiles.bin: Update to 2025-11-27 firmware
  * firmware: 2712: 2711: Update to 2025-11-27
  * tools: Move APT release scripts into a sub-directory
  * tools: Fix base path in release-scripts/get-latest-fw
  * firmware: 2712: 2711: Move to the 2025-12-08 release
  * apt: update rpi-eeprom dependency

  [ martamomotko ]
  * rpiboot: Output metadata to stdout when path not provided or invalid
  * rpiboot: Enable metadata output by default when metadata is received
    Metadata information is now written to stdout by default when received
    from BCM2712/2711 devices. The -j flag can be used to specify a
    directory for a JSON file output instead. To instruct recovery.bin to
    stop sending metadata, explicitly set recovery_metadata=0 in
    config.txt.

 -- Tim Gover <tim.gover@raspberrypi.com>  Tue, 09 Dec 2025 13:57:30 +0000

=== debian/control ===
--- 
+++ 
@@ -2,13 +2,13 @@
 Section: utils
 Priority: optional
 Maintainer: Serge Schneider <serge@raspberrypi.com>
-Build-Depends: debhelper-compat (= 13), libusb-1.0-0-dev, pkg-config, rpi-eeprom (>= 28.9), xxd
+Build-Depends: debhelper-compat (= 13), libusb-1.0-0-dev, pkg-config, rpi-eeprom (>= 28.10), xxd
 Standards-Version: 4.5.1
 Homepage: https://github.com/raspberrypi/usbboot
 
 Package: rpiboot
 Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}, python3, rpi-eeprom (>= 28.9)
+Depends: ${shlibs:Depends}, ${misc:Depends}, python3, rpi-eeprom (>= 28.10)
 Description: Raspberry Pi USB booting code
  USB MSD boot code which should work on the Raspberry Pi model A,
  Compute Module, Compute Module 3, Compute Module 4, Compute Module 5,

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@

# Makefile does not follow any conventions
override_dh_auto_install:
	true

override_dh_strip:
	dh_strip -Xstart.elf -Xstart4.elf

override_dh_install:
	# Copy the pinned firmware version
	rm -rf temp
	mkdir -p temp/firmware/2711
	mkdir -p temp/firmware/2712

	cp /lib/firmware/raspberrypi/bootloader-2711/latest/pieeprom-2025-12-08.bin temp/firmware/2711/pieeprom.bin
	cp /lib/firmware/raspberrypi/bootloader-2711/latest/recovery.bin temp/firmware/2711/recovery.bin
	cp /lib/firmware/raspberrypi/bootloader-2712/latest/pieeprom-2025-12-08.bin temp/firmware/2712/pieeprom.bin
	cp /lib/firmware/raspberrypi/bootloader-2712/latest/recovery.bin temp/firmware/2712/recovery.bin
	dh_install
	find $(CURDIR)/debian -name .gitignore -delete
	rm -rf temp

## rpiboot 20251209~095558

=== debian/changelog ===
rpiboot (20251209~095558) trixie; urgency=medium

  * tools: Fix base path in release-scripts/get-latest-fw
  * firmware: 2712: 2711: Move to the 2025-12-08 release
  * apt: update rpi-eeprom dependency

 -- Tim Gover <tim.gover@raspberrypi.com>  Tue, 09 Dec 2025 12:42:00 +0000

## rpiboot 20251214~140909

=== debian/changelog ===
rpiboot (20251214~140909) trixie; urgency=medium

  [ Tim Gover ]
  * bootcode: Use USB2 HS mode for loading start.elf / ramdisk

  [ Michele Rizzo ]
  * Increase handled port number up to 255
  * Adjust port number range to 0-98

  [ Nicolai Buchwitz ]
  * Makefile: add platform-specific default mass-storage-gadget directory

  [ Ansgar Schmidt ]
  * Fixing compiler problem of main

 -- Tim Gover <tim.gover@raspberrypi.com>  Mon, 15 Dec 2025 15:04:23 +0000

## rpiboot 20260210~145518~bookworm

=== Makefile ===
--- 
+++ 
@@ -3,9 +3,14 @@
 GIT_VER=$(shell git rev-parse HEAD 2>/dev/null | cut -c1-8 || echo "")
 HAVE_XXD=$(shell xxd -v >/dev/null 2>/dev/null && echo y)
 INSTALL_PREFIX?=/usr
+ifeq ($(OS),Windows_NT)
+    DEFAULT_MSG_DIR ?= "C:/Program Files (x86)/Raspberry Pi/mass-storage-gadget64/"
+else
+    DEFAULT_MSG_DIR ?= $(INSTALL_PREFIX)/share/rpiboot/mass-storage-gadget64/
+endif
 
 rpiboot: main.c bootfiles.c decode_duid.c msd/bootcode.h msd/start.h msd/bootcode4.h
-	$(CC) -Wall -Wextra -g $(CPPFLAGS) $(CFLAGS) -o $@ main.c bootfiles.c decode_duid.c `pkg-config --cflags --libs libusb-1.0` -DGIT_VER="\"$(GIT_VER)\"" -DPKG_VER="\"$(PKG_VER)\"" -DBUILD_DATE="\"$(BUILD_DATE)\"" -DINSTALL_PREFIX=\"$(INSTALL_PREFIX)\" $(LDFLAGS)
+	$(CC) -Wall -Wextra -g $(CPPFLAGS) $(CFLAGS) -o $@ main.c bootfiles.c decode_duid.c `pkg-config --cflags --libs libusb-1.0` -DGIT_VER="\"$(GIT_VER)\"" -DPKG_VER="\"$(PKG_VER)\"" -DBUILD_DATE="\"$(BUILD_DATE)\"" -DDEFAULT_MSG_DIR=\"$(DEFAULT_MSG_DIR)\" $(LDFLAGS)
 
 ifeq ($(HAVE_XXD),y)
 %.h: %.bin

=== debian/changelog ===
rpiboot (20260210~145518~bookworm) bookworm; urgency=medium

  [ Tim Gover ]
  * bootcode: Use USB2 HS mode for loading start.elf / ramdisk
  * firmware: 2711: Update to 2026-01-09
  * firmware: 2712: Update to 2026/01/21 to match manufacture
  * firmware: 2711: 2712: Move to pieeprom-2026-02-06
  * apt: update rpi-eeprom dependency

  [ Michele Rizzo ]
  * Increase handled port number up to 255
  * Adjust port number range to 0-98

  [ Nicolai Buchwitz ]
  * Makefile: add platform-specific default mass-storage-gadget directory

  [ Ansgar Schmidt ]
  * Fixing compiler problem of main

  [ Mathew Blowers ]
  * Latest wdi-simple
  * mass storage gadget link no longer just CM4 and CM5

 -- Tim Gover <tim.gover@raspberrypi.com>  Tue, 10 Feb 2026 15:03:02 +0000

=== debian/control ===
--- 
+++ 
@@ -2,13 +2,13 @@
 Section: utils
 Priority: optional
 Maintainer: Serge Schneider <serge@raspberrypi.com>
-Build-Depends: debhelper-compat (= 13), libusb-1.0-0-dev, pkg-config, rpi-eeprom (>= 28.10), xxd
+Build-Depends: debhelper-compat (= 13), libusb-1.0-0-dev, pkg-config, rpi-eeprom (>= 28.13), xxd
 Standards-Version: 4.5.1
 Homepage: https://github.com/raspberrypi/usbboot
 
 Package: rpiboot
 Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}, python3, rpi-eeprom (>= 28.10)
+Depends: ${shlibs:Depends}, ${misc:Depends}, python3, rpi-eeprom (>= 28.13)
 Description: Raspberry Pi USB booting code
  USB MSD boot code which should work on the Raspberry Pi model A,
  Compute Module, Compute Module 3, Compute Module 4, Compute Module 5,

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@

# Makefile does not follow any conventions
override_dh_auto_install:
	true

override_dh_strip:
	dh_strip -Xstart.elf -Xstart4.elf

override_dh_install:
	# Copy the pinned firmware version
	rm -rf temp
	mkdir -p temp/firmware/2711
	mkdir -p temp/firmware/2712

	cp /lib/firmware/raspberrypi/bootloader-2711/latest/pieeprom-2026-02-06.bin temp/firmware/2711/pieeprom.bin
	cp /lib/firmware/raspberrypi/bootloader-2711/latest/recovery.bin temp/firmware/2711/recovery.bin
	cp /lib/firmware/raspberrypi/bootloader-2712/latest/pieeprom-2026-02-06.bin temp/firmware/2712/pieeprom.bin
	cp /lib/firmware/raspberrypi/bootloader-2712/latest/recovery.bin temp/firmware/2712/recovery.bin
	dh_install
	find $(CURDIR)/debian -name .gitignore -delete
	rm -rf temp

## rpiboot 20260210~145518

=== debian/changelog ===
rpiboot (20260210~145518) trixie; urgency=medium

  * salsa: Remove extract block
  * firmware: 2711: 2712: Move to pieeprom-2026-02-06
  * apt: update rpi-eeprom dependency

 -- Tim Gover <tim.gover@raspberrypi.com>  Tue, 10 Feb 2026 15:01:50 +0000

rpiboot (20260202~161355) trixie; urgency=medium

  [ Tim Gover ]
  * firmware: 2711: Update to 2026-01-09
  * firmware: 2712: Update to 2026/01/21 to match manufacture
  * Require rpi-eeprom 28.12
  * apt: update rpi-eeprom dependency

  [ Mathew Blowers ]
  * Latest wdi-simple
  * mass storage gadget link no longer just CM4 and CM5

 -- Tim Gover <tim.gover@raspberrypi.com>  Mon, 02 Feb 2026 16:20:30 +0000
